Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.drools.planner.core.heuristic.selector.entity.pillar
Class SameValuePillarSelector

    java.lang.Object
      org.drools.planner.core.heuristic.selector.AbstractSelector
          org.drools.planner.core.heuristic.selector.entity.pillar.SameValuePillarSelector

All Implemented Interfaces:
  Iterable<List<Object>>, EventListener, ListIterable<List<Object>>, SelectionCacheLifecycleListener, PillarSelector, Selector, SolverPhaseLifecycleListener, SolverLifecycleListener

    public class SameValuePillarSelector

extends AbstractSelector
implements PillarSelector, SelectionCacheLifecycleListener

This is the common `PillarSelector` implementation.

Field Summary
`protected List<List<Object>>` | `cachedPillarList`
`protected EntitySelector` | `entitySelector`
`protected boolean` | `randomSelection`
`protected Collection<PlanningVariableDescriptor>` | `variableDescriptors`

Fields inherited from class org.drools.planner.core.heuristic.selector.AbstractSelector
`logger, solverPhaseLifecycleSupport, workingRandom`

Constructor Summary
`SameValuePillarSelector(EntitySelector entitySelector, Collection<PlanningVariableDescriptor> variableDescriptors, boolean randomSelection)`

Method Summary
`void` | `constructCache(DefaultSolverScope solverScope)`
`void` | `disposeCache(DefaultSolverScope solverScope)`
`PlanningEntityDescriptor` | `getEntityDescriptor()`
`long` | `getSize()` A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
`boolean` | `isContinuous()` If true, then `Selector.isNeverEnding()` is also true.
`boolean` | `isNeverEnding()` Is true if `Selector.isContinuous()` is true or if this selector is in random order (for most cases).
`Iterator<List<Object>>` | `iterator()`
`ListIterator<List<Object>>` | `listIterator()` See `List.listIterator()`
`ListIterator<List<Object>>` | `listIterator(int index)` See `List.listIterator()`
`String` | `toString()`

Methods inherited from class org.drools.planner.core.heuristic.selector.AbstractSelector
`phaseEnded, phaseStarted, solvingEnded, solvingStarted, stepEnded, stepStarted`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.drools.planner.core.phase.event.SolverPhaseLifecycleListener
`phaseEnded, phaseStarted, stepEnded, stepStarted`

Methods inherited from interface org.drools.planner.core.solver.event.SolverLifecycleListener
`solvingEnded, solvingStarted`

Field Detail

### entitySelector

    protected final EntitySelector entitySelector

### variableDescriptors

    protected final Collection<PlanningVariableDescriptor> variableDescriptors

### randomSelection

    protected final boolean randomSelection

### cachedPillarList

    protected List<List<Object>> cachedPillarList

Constructor Detail

### SameValuePillarSelector

    public SameValuePillarSelector(EntitySelector entitySelector,
                                   Collection<PlanningVariableDescriptor> variableDescriptors,
                                   boolean randomSelection)

Method Detail

### getEntityDescriptor

    public PlanningEntityDescriptor getEntityDescriptor()

  Specified by:
    `getEntityDescriptor` in interface `PillarSelector`
  Returns:
    never null

### constructCache

    public void constructCache(DefaultSolverScope solverScope)

  Specified by:
    `constructCache` in interface `SelectionCacheLifecycleListener`

### disposeCache

    public void disposeCache(DefaultSolverScope solverScope)

  Specified by:
    `disposeCache` in interface `SelectionCacheLifecycleListener`

### isContinuous

    public boolean isContinuous()

  Description copied from interface: `Selector`
  If true, then `Selector.isNeverEnding()` is also true.

  Specified by:
    `isContinuous` in interface `Selector`
  Returns:
    true if any of the value ranges are continuous (as in for example every double value between 1.2 and 1.4)

### isNeverEnding

    public boolean isNeverEnding()

  Description copied from interface: `Selector`
  Is true if `Selector.isContinuous()` is true or if this selector is in random order (for most cases). Is never true when this selector is in shuffled order (which is less scalable but more exact).

  Specified by:
    `isNeverEnding` in interface `Selector`
  Returns:
    true if the `Iterator.hasNext()` of the `Iterator` created by `Iterable.iterator()` never returns false.

### getSize

    public long getSize()

  Description copied from interface: `Selector`
  A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.

  Specified by:
    `getSize` in interface `Selector`
  Returns:
    the approximate number of elements generated by this `Selector`, always >= 0

### iterator

    public Iterator<List<Object>> iterator()

  Specified by:
    `iterator` in interface `Iterable<List<Object>>`

### listIterator

    public ListIterator<List<Object>> listIterator()

  Description copied from interface: `PillarSelector`
  See `List.listIterator()`

  Specified by:
    `listIterator` in interface `ListIterable<List<Object>>`
  Specified by:
    `listIterator` in interface `PillarSelector`
  Returns:
    never null, see `List.listIterator()`.

### listIterator

    public ListIterator<List<Object>> listIterator(int index)

  Description copied from interface: `PillarSelector`
  See `List.listIterator()`

  Specified by:
    `listIterator` in interface `ListIterable<List<Object>>`
  Specified by:
    `listIterator` in interface `PillarSelector`
  Parameters:
    `index` - lower than `Selector.getSize()`, see `List.listIterator(int)`.
  Returns:
    never null, see `List.listIterator(int)`.

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2013 JBoss by Red Hat. All Rights Reserved.